<template>
  <div>
    <v-data-table
      :headers="headers"
      :items="AllCategories"
      sort-by="key"
      :loading="loading"
      loading-text="Buscando..."
      class="elevation-5 px-5 py-2"
    >
      <template v-slot:top>
        <v-toolbar flat>
          <v-toolbar-title>Categorías</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <v-dialog v-model="dialog" max-width="350px">
            <template v-slot:activator="{ on, attrs }">
              <v-btn color="primary" dark class="mb-2" v-bind="attrs" v-on="on">
                <v-icon left> mdi-plus </v-icon>
                Categoría
              </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">{{ formTitle }}</span>
              </v-card-title>

              <v-card-text>
                <v-container>
                  <v-row>
                    <v-col cols="12" sm="12" md="12">
                      <v-text-field
                        v-model="editedItem.key"
                        label="Clave"
                        :error-messages="message"
                        :error="errorExist"
                        :disabled="editedIndex > -1"
                        required
                      ></v-text-field>
                      <v-text-field
                        v-model="editedItem.name"
                        label="Nombre"
                        required
                      ></v-text-field>
                      <v-text-field
                        v-model="editedItem.desct"
                        label="Descuento"
                        required
                      ></v-text-field>
                    </v-col>
                  </v-row>
                </v-container>
              </v-card-text>

              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="grey darken-2" text @click="close">
                  Cancel
                </v-btn>
                <v-btn
                  color="blue darken-1"
                  text
                  :loading="loadingSave"
                  :disabled="loadingSave"
                  @click="save"
                >
                  {{ editedIndex === -1 ? 'Registrar' : 'Actualizar' }}
                </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
          <v-dialog v-model="dialogDelete" max-width="400px">
            <v-card>
              <v-card-title class="text-h6"> Eliminar Categoría </v-card-title>
              <v-card-text class="pb-0">
                <v-container>
                  <v-row>
                    <v-col class="text-center subtitle-1">
                      ¿Desea eliminar la categoria
                      <strong>{{ editedItem.name }}</strong
                      >?
                    </v-col>
                  </v-row>
                </v-container>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="grey darken-2" text @click="closeDelete"
                  >Cerrar</v-btn
                >
                <v-btn
                  color="red darken-1"
                  text
                  :loading="loadingDelete"
                  :disabled="loadingDelete"
                  @click="deleteItemConfirm"
                  >Eliminar</v-btn
                >
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:item.actions="{ item }" class="text-center">
        <v-btn icon color="blue" @click="editItem(item)">
          <v-icon>mdi-pencil</v-icon>
        </v-btn>
        <v-btn icon color="red" @click="deleteItem(item)">
          <v-icon>mdi-delete</v-icon>
        </v-btn>
      </template>
      <template v-slot:no-data> No hay registros </template>
    </v-data-table>
  </div>
</template>
<script lang="ts">
import { Vue, Component, getModule, Watch } from 'nuxt-property-decorator'
import CategoryStore from '@/store/category'

@Component({
  name: 'categoria',
  middleware: ['isAdmin'],
})
export default class Categoria extends Vue {
  /* Datatable */
  dialog = false
  dialogDelete = false
  loading = false
  loadingSave = false
  loadingDelete = false
  message = ''
  errorExist = false
  headers = [
    {
      text: 'Clave',
      align: 'start',
      value: 'key',
    },
    { text: 'Nombre', value: 'name' },
    { text: 'Descuento %', value: 'desct' },
    { text: 'Acción', value: 'actions', sortable: false, align: 'center' },
  ]
  desserts: any[] = []
  editedIndex = -1
  editedItem = {
    key: null,
    name: '',
    desct: null,
  }
  defaultItem = {
    key: null,
    name: '',
    desct: null,
  }

  get formTitle() {
    return this.editedIndex === -1
      ? 'Agregar Categoría'
      : 'Actualizar Categoría'
  }

  @Watch('dialog')
  onDialog(val: any) {
    val || this.close()
  }

  @Watch('dialogDelete')
  onDialogDelete(val: any) {
    val || this.closeDelete()
  }

  editItem(item: any) {
    this.editedIndex = this.AllCategories.indexOf(item)
    this.editedItem = Object.assign({}, item)
    this.dialog = true
  }

  deleteItem(item: any) {
    this.editedIndex = this.AllCategories.indexOf(item)
    this.editedItem = Object.assign({}, item)
    this.dialogDelete = true
  }

  deleteItemConfirm() {
    this.loadingDelete = true
    const deleteCategory = getModule(CategoryStore, this.$store)
    deleteCategory.deleteCategory(this.editedItem).then(() => {
      this.closeDelete()
      this.getAllCategories()
      this.loadingDelete = false
    })
  }

  close() {
    this.dialog = false
    this.$nextTick(() => {
      this.editedItem = Object.assign({}, this.defaultItem)
      this.editedIndex = -1
    })
  }

  closeDelete() {
    this.dialogDelete = false
    this.$nextTick(() => {
      this.editedItem = Object.assign({}, this.defaultItem)
      this.editedIndex = -1
    })
  }

  save() {
    this.loadingSave = true
    this.errorExist = false
    this.message = ''
    if (this.editedIndex > -1) {
      console.log('edit', this.editedItem)
      const update = getModule(CategoryStore, this.$store)
      update.updateCategory(this.editedItem).then((e) => {
        this.getAllCategories()
        this.close()
        this.loadingSave = false
      })
    } else {
      const create = getModule(CategoryStore, this.$store)
      console.log('save', this.editedItem)
      create.createCategory(this.editedItem).then((e) => {
        if (e.status === 500 && e.data.error.code === '23505') {
          this.message = 'La clave debe ser única'
          this.errorExist = true
          this.loadingSave = false
          return
        }
        this.getAllCategories()
        this.close()
        this.loadingSave = false
      })
    }
  }
  /* Datatable */

  get AllCategories() {
    if (this.loading) {
      return []
    } else {
      const categories = getModule(CategoryStore, this.$store)
      return categories.listCategory
    }
  }

  getAllCategories() {
    this.loading = true
    const categoriesModule = getModule(CategoryStore, this.$store)
    categoriesModule.getCategories().then(() => {
      this.loading = false
    })
  }
  created() {
    this.getAllCategories()
  }
}
</script>